



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android --ListView使用ArrayAdapter</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android --ListView使用ArrayAdapter</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 11:28:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1、继承ArrayAdapter</p>
<div>
<pre class="prettyprint linenums">public class TimerDataAdapter extends ArrayAdapter&lt;TimerDataListItem&gt; {
    //数据ID
    int dataResourceID = 0;
    //内容
    private Context mContext;
    //数据列表
    private List&lt;TimerDataListItem&gt; mtimerDataList;

    private TextView area = null;
    private TextView dev = null;
    private TextView val = null;
    private TextView limit = null;
    private TextView updatetime = null;

    //构造函数
    public TimerDataAdapter(Context context, int dataResourceId,List&lt;TimerDataListItem&gt; timerDataList) {
        super(context, dataResourceId,timerDataList);
        this.dataResourceID = dataResourceId;
        this.mContext = context;
        this.mtimerDataList = timerDataList;
    }

    @Override
    public int getCount() {
        return mtimerDataList.size();
    }

    @Override
    public TimerDataListItem getItem(int position) {
        return mtimerDataList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        TimerDataListItem item = getItem(position);

        if(item != null) {
            if (convertView == null) {
                convertView = LayoutInflater.from(mContext).inflate(
                        dataResourceID, null);
                area = (TextView) convertView.findViewById(R.id.array_area);
                dev = (TextView) convertView.findViewById(R.id.array_dev);
                val = (TextView) convertView.findViewById(R.id.array_data);
                limit = (TextView) convertView.findViewById(R.id.array_limit);
                updatetime = (TextView) convertView.findViewById(R.id.array_updatetime);
            }

            area.setText(item.getArea());
            dev.setText(item.getDev());
            val.setText(item.getVal());
            limit.setText(item.getlimit());
            updatetime.setText(item.getUpdatetime());

            int status = item.getStatus();
            if (status == 0) {
                val.setBackgroundColor(0xFF156BCC);//0代表正常
            } else if (status == 1) {
                val.setBackgroundColor(0xFFFE3044);//1代表不正常
            } else {
                val.setBackgroundColor(0xFFF2EC10);//2代表超时数值
            }
        }
        return convertView;
    }
}</pre>
</div>
<p>2、Fragment中设置Adapter</p>
<div>
<pre class="prettyprint linenums">mAdapter = new TimerDataAdapter(this.getActivity()
                ,R.layout.fragment_timerdata_list_item,mtimerDataList);</pre>
</div>
<div>
<pre class="prettyprint linenums">    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        //实例化fragment布局。动态的有grid和list俩种
        View view = inflater.inflate(R.layout.fragment_timerdata_list, container, false);

        View headerView = inflater.inflate(R.layout.fragment_timerdata_list_header, null);
        mListView = (ListView) view.findViewById(android.R.id.list);
        mListView.addHeaderView(headerView);

        // Set the adapter
        mListView.setAdapter(mAdapter);

        mswipeLayout =(SwipeRefreshLayout)view.findViewById(R.id.id_swipe_ly);
        mswipeLayout.setOnRefreshListener(this);
        mswipeLayout.setColorSchemeResources(android.R.color.holo_blue_light, android.R.color.holo_blue_light,
                android.R.color.holo_blue_light, android.R.color.holo_blue_light);

        return view;
    }</pre>
</div>
<p>3、使用swiperefreshlayout&nbsp;下拉刷新</p>
<p>布局</p>
<div>
<pre class="prettyprint linenums">    &lt;android.support.v4.widget.SwipeRefreshLayout
        android:id="@+id/id_swipe_ly"
        android:layout_width="match_parent"
        android:layout_height="match_parent" &gt;

    &lt;ListView android:id="@android:id/list"
        android:layout_width="match_parent"
        android:layout_height="match_parent"
        android:drawSelectorOnTop="false"
        android:fastScrollEnabled="true"/&gt;

    &lt;!--&lt;TextView android:id="@android:id/empty" --&gt;
        &lt;!--android:layout_width="match_parent"--&gt;
        &lt;!--android:layout_height="match_parent" --&gt;
        &lt;!--android:gravity="center" /&gt;--&gt;
    &lt;/android.support.v4.widget.SwipeRefreshLayout&gt;</pre>
</div>
<p>刷新</p>
<div>
<pre class="prettyprint linenums">@Override
    public void onRefresh()
    {
        mHandler.sendEmptyMessageDelayed(0, 2000);
    }

    private Handler mHandler = new Handler()
    {
        public void handleMessage(android.os.Message msg)
        {
            getTimerData();
            mAdapter.notifyDataSetChanged();
            mswipeLayout.setRefreshing(false);
        }
    };</pre>
</div>
<p>4、空指针异常&nbsp;java.lang.NullPointerException</p>
<p>Adapter中getView内声明控件变量有关，出现刷新Adapter错误</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gmzz49.html">&lbrack;LeetCode&rsqb; Super Ugly Number 超级丑陋数</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdg668.html">浏览器对象模型BOM小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4kgxj9.html">think in java学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jg36e9.html">自然语言23&lowbar;Text Classification with NLTK</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z2rxv8.html">部分LINUX系统由图形界面启动变更为命令行界面启动的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnx7jx9.html">一个通用的makefile</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlykyk9.html">2&period;16 最长递增子序列 LIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw67ey9.html">COJ1012 WZJ的数据结构（十二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrx709.html">IE&comma;Chrome滚动条样式CSS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew2jj9.html">【原】rsync的详细参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wol03q.html">hbase性能调优之压缩测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/95022768.html">CSS面试细节整理（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rv0lj9.html">Java&period;&period;&period;点点点语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv5r638.html">Hadoop记录-NameNode优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyr43jq.html">JVM&amp;&num;183&semi;垃圾收集器与内存分配策略之对象是否可被回收！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv5lg38.html">流媒体服务器SRS部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj41j69.html">理解socket&period;io&lpar;一&rpar;---相关的API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvg4lz8.html">caffe在win10下的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rowvj9.html">修改tomcat默认端口号</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g5m00q.html">Linux系列：Fedora虚拟机设置固定IP上网（配置IP、网关、DNS、防止resolv&period;conf被重写）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/390wm3oq.html">lucene索引日期和数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q275e38.html">Ubuntu 启动停止脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rjn6r8.html">PHP &dollar;&lowbar;SERVER 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx0l1dq.html">mysql join表连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mop529.html">如何用Apache TCPMon来截获SOAP消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k3v16q.html">shell的if else 以及大于&comma;小于等逻辑表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/r930vdw9.html">intervention&sol;image     intervention&sol;imagecache</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z54l38.html">Connection Management and Security</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jylv49.html">Android Studio 快捷键使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rj6y48.html">addevent兼容函数 &amp;amp&semi;&amp;amp&semi; 阻止默认行为 &amp;amp&semi;&amp;amp&semi; 阻止传播</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
